bwdefine("BWLocalStorage",[],function(){"use strict";return{GetItem:function(e){return localStorage.getItem(e)},RemoveItem:function(e){localStorage.removeItem(e)},SetItem:function(e,t){localStorage.setItem(e,t)},Clear:function(){localStorage.clear()}}}),bwdefine("BWKSLocal",["BWLocalStorage","bw/logging"],function(e,t){"use strict";function r(e){return"iBookWidgets/"+e}var n=t.createLogger("BWKSLocal");return{getItem:function(t){return n.debug("getItem "+r(t)),e.GetItem(r(t))},setItem:function(t,o){n.debug("setItem "+r(t));try{return e.SetItem(r(t),o),!0}catch(e){return!1}},removeItem:function(t){n.debug("removeItem "+r(t)),e.RemoveItem(r(t))},clear:function(){n.debug("clear"),e.Clear()}}}),bwdefine("bw/storage/BWDSError",[],function(){"use strict";return{BWDS_ERROR_INTERNAL:0,BWDS_ERROR_UNKNOWN:1,BWDS_ERROR_UNAVAILABLE:2,BWDS_ERROR_WRONG_ATTRIB:3,BWDS_ERROR_FULL:4,BWDS_ERROR_SECURITY:5}}),bwdefine("BWDSUtil",["bw/storage/BWDSError"],function(e){"use strict";function t(e){var t=Array.prototype.slice.call(arguments,1);try{e&&e.apply(null,t)}catch(e){console.log("Received error when executing callback: "+e)}}function r(r,o,i){18==r.code?t(o,n.error(e.BWDS_ERROR_SECURITY,"AsyncBWDS Security Error: problem when accessing: "+JSON.stringify(r))):t(o,n.error(e.BWDS_ERROR_INTERNAL,"AsyncBWDS Error: problem when accessing: "+JSON.stringify(r))),i&&i()}var n={},o=function(e){return e<10?"0"+e:""+e};return n.getDateTime=function(){var e=new Date,t=o(e.getFullYear())+"-"+o(1+e.getMonth())+"-"+o(e.getDate())+" "+o(e.getHours())+":"+o(e.getMinutes())+":"+o(e.getSeconds());return t},n.error=function(e,t){return{code:e,message:t}},n.trimLeadingSlash=function(e){return e.length>0&&"/"==e[0]?e.substr(1):e},n.newCallbackQueue=function(){var e={};return e.executeList=[],e.executing=!1,e.executeNext=function(){if(e.executeList.length>0){e.executing=!0;var t=e.executeList.shift();t.cb(e.executeNext)}else e.executing=!1},e.executeSequential=function(t,r){if(void 0!=r&&r!==!1&&null!=r&&e.executeList.length>0)for(var n=0;n<e.executeList.length;++n)e.executeList[n].tag==r&&e.executeList.splice(n,1);e.executeList.push({cb:t,tag:r}),e.executing||e.executeNext()},e},n.callSafe=t,n.handleException=r,n}),bwdefine("bw/storage/WebSQLAsyncKeyStore",["bw/logging"],function(e){"use strict";function t(e,t,n){r.error("WebSQL Error: executeSQL triggered error: "+n.message),void 0!=e&&e(n)}var r=e.createLogger("WebSQLAsyncKeyStore"),n=function(e,t){this.name=e||"BWDS1",this.initialized=!1,this.valid=!1,this.db=null,this.openDatabase="undefined"!=typeof t?t:window.hasOwnProperty("openDatabase")?window.openDatabase.bind(window):function(){console.error("webSQL not supported")}};return n.prototype._prepareDatabase=function(e,t){var n=this.openDatabase(this.name,"","Offline BW storage",5242880);return""==n.version&&(r.debug("WebSQL: creating db"),n.changeVersion(n.version,"1.0",function(e){r.debug("WebSQL: creating table"),e.executeSql("CREATE TABLE keyvalue (keyname PRIMARY KEY, dir, name, value, attribs)")},t)),n},n.prototype._initializeAndRun=function(e,t){if(this.initialized)return void(this.valid?void 0!==e&&e():(r.debug("WebSQL Error: Database is initialized but not valid, calling error"),void 0!==t&&t(this.error)));if(this.initialized=!0,this.openDatabase){try{r.debug("WebSQL: initializing database"),this.db=this._prepareDatabase(function(e){r.debug("WebSQL Error: Received error while preparing database: "+e.message)}),this.valid=!0}catch(e){switch(e.code){case e.SECURITY_ERR:r.debug("WebSQL Error: Received security error: "+e.message);break;case e.INVALID_STATE_ERR:r.debug("WebSQL Error: Received invalid state error: "+e.message);break;default:r.debug("WebSQL Error: Received error "+e.code+": "+e.message)}return this.valid=!1,this.error=e,void t(e)}e()}else r.debug("WebSQL Error: No WebSQL database available"),this.valid=!1,this.error={code:9999,message:"WebSQL Error: No WebSQL database available"},t(this.error)},n.prototype._initializeAndRunTransaction=function(e,t,n){var o=this;this._initializeAndRun(function(){o.db[e?"readTransaction":"transaction"](function(e){try{t(e)}catch(e){r.error("Error while executing transaction: "+e.code+": "+e.message),void 0!=n&&n(e)}},function(e){r.error("WebSQL Error: "+e.code+" starting transaction :"+e.message),o.valid=!1,o.initialized=!1,void 0!=n&&n(e)})},function(e){r.error("WebSQL Error: database not valid"),void 0!=n&&n(e)})},n.prototype._initializeAndRunReadTransaction=function(e,t){this._initializeAndRunTransaction(!0,e,t)},n.prototype._initializeAndRunReadWriteTransaction=function(e,t){this._initializeAndRunTransaction(!1,e,t)},n.prototype.getItemsAsync=function(e,n,o){return 0===e.length?(r.debug("WebSQL Error: getItemsAsync without names"),void o({code:9999,message:"WebSQL Error: getItemsAsync without names"})):void this._initializeAndRunReadTransaction(function(i){for(var a="",s=0;s<e.length;++s)a+=(""==a?"":", ")+"?";i.executeSql("SELECT keyname, value, attribs FROM keyvalue where keyname IN ("+a+")",e,function(e,t){for(var o={},i=0;i<t.rows.length;++i){var a=t.rows.item(i);o[a.keyname]=a,r.debug("WebSQL: read ("+a.keyname+") = "+a.value)}n(o)},t.bind(null,o))},o)},n.prototype.getDirAttribs=function(e,r,n){this._initializeAndRunReadTransaction(function(o){o.executeSql("SELECT keyname, attribs FROM keyvalue where dir = ?",[e],function(e,t){for(var n={},o=0;o<t.rows.length;++o){var i=t.rows.item(o);n[i.keyname]=i.attribs}r(n)},t.bind(null,n))},n)},n.prototype.setItemsAsync=function(e,n,o){if(0===e.length)return r.error("WebSQL Error: setItemsAsync without names"),void o({code:9999,message:"setItemsAsync without names"});if(e.length>1)return r.error("WebSQL Error: setItemsAsync can only handle 1 item"),void o({code:9999,message:"setItemsAsync can only handle 1 item"});var i=e[0];this._initializeAndRunReadWriteTransaction(function(a){var s=i.key,c=s.lastIndexOf("/"),u="",l="";c!=-1&&(u=s.substring(0,c)),l=s.substring(c+1),a.executeSql("INSERT OR REPLACE INTO 'keyvalue' ( 'keyname', 'dir', 'name', 'value', 'attribs' ) VALUES ( ? , ? , ?, ? , ? )",[i.key,u,l,i.value,i.attribs],function(t,a){a.rowsAffected!=e.length?(r.error("WebSQL Error: store error on key "+name),o({code:9999,message:"WebSQL store error: wrong # rows affected"})):void 0!=n?(r.debug("WebSQL: wrote ("+i.key+")"),n()):r.error("WebSQL Error: setItemsAsync no OK function")},t.bind(null,o))},o)},n.prototype.removeItemsAsync=function(e,n,o){return 0===e.length?(r.debug("WebSQL Error: removeItemsAsync without names"),void o({code:9999,message:"WebSQL Error: removeItemsAsync without names"})):void this._initializeAndRunReadWriteTransaction(function(i){for(var a="",s=0;s<e.length;++s)a+=(""==a?"":", ")+"?";i.executeSql("DELETE FROM keyvalue where keyname IN ("+a+")",e,function(t,o){r.debug("WebSQL: removed "+e.join(", ")),void 0!=n&&n()},t.bind(null,o))},o)},n.prototype.clearAllAsync=function(e,n){this._initializeAndRunReadWriteTransaction(function(o){o.executeSql("DELETE FROM keyvalue",[],function(t,n){r.debug("WebSQL: Cleared all"),void 0!=e&&e()},t.bind(null,n))},n)},n}),bwdefine("bw/storage/NativeSQLAsyncKeyStore",["bw/CallbackBridge","bw/logging"],function(e,t){"use strict";var r=t.createLogger("NativeSQLAsyncKeyStore"),n=new e;n.startListening();var o=function(e){function t(e){var t=String.fromCharCode(29);return e=e.map(function(e){return e.replace(new RegExp(",","g"),t)}),e.join()}e=e||function(e){var t=document.createElement("IFRAME");t.setAttribute("src",e),t.setAttribute("height","1px"),t.setAttribute("width","1px"),document.documentElement.appendChild(t),t.parentNode.removeChild(t),t=null};var o={};return o.resultForCallback=function(e,t){n.processCallback(e,t)},o.runningInIframe=function(){try{return window.self!==window.top}catch(e){return!0}},o.callObjC=function(t,r,i){var a=n.registerCallbacks(r,i),s="'"+a.ok+"'",c="'"+a.error+"'",u="BWKSNativeSQL.resultForCallback";o.runningInIframe()&&(u="function BWKSNativeSQL_callback_wrapper(callbackID, arg) { window.postMessage({ 'command': callbackID, 'arg': arg, 'to': '_widget' }, '*'); }; BWKSNativeSQL_callback_wrapper"),e(t+"&okCallbackId="+s+"&errorCallbackId="+c+"&callbackFunc="+u)},o.getItemsAsync=function(e,n,i){if(0==e.length)return r.error("NativeSQL Error: getItemsAsync without names"),void i({message:"NativeSQL Error: getItemsAsync without names"});var a="js2objc://getItemsAsync?names="+t(e);o.callObjC(a,n,i)},o.getDirAttribs=function(e,t,r){var n="js2objc://getDirAttribsAsync?dirname="+e;o.callObjC(n,t,r)},o.setItemsAsync=function(e,t,n){if(0==e.length)return r.error("NativeSQL Error: setItemsAsync without names"),void n({message:"setItemsAsync without names"});if(e.length>1)return r.error("NativeSQL Error: setItemsAsync can only handle 1 item"),void n({message:"setItemsAsync can only handle 1 item"});var i=e[0],a="js2objc://setItemAsync?keyname="+encodeURIComponent(i.key)+"&value="+encodeURIComponent(i.value)+"&attribs="+encodeURIComponent(i.attribs);o.callObjC(a,t,n)},o.removeItemsAsync=function(e,n,i){if(0==e.length)return r.error("NativeSQL Error: removeItemsAsync without names"),void i({message:"NativeSQL Error: removeItemsAsync without names"});var a="js2objc://removeItemsAsync?names="+t(e);o.callObjC(a,n,i)},o.clearAllAsync=function(e,t){t("Clearing all data in BookWidgets app is not supported")},o};return o}),bwdefine("bw/storage/ProxiedAsyncKeyStore",["bw/WindowAsyncCommandSender","bw/qs"],function(e,t){"use strict";var r=function(t,r,n){var o="*";this.sender=new e(t,o),this.token=n};return r.prototype.postMessage=function(e,t,r){this.token&&(e.token=this.token),this.sender.send(e,function(e,n){return e?r(e):t(n)})},r.prototype.getItemsAsync=function(e,t,r){this.postMessage({command:"getItems",names:e},t,r)},r.prototype.setItemsAsync=function(e,t,r){this.postMessage({command:"setItems",items:e},t,r)},r.prototype.removeItemsAsync=function(e,t,r){this.postMessage({command:"removeItems",names:e},t,r)},r.prototype.clearAllAsync=function(e,t){this.postMessage({command:"clear"},e,t)},r.prototype.getDirAttribs=function(e,t,r){this.postMessage({command:"getDirAttribs",name:e},t,r)},r}),bwdefine("bw/storage/AsyncKeyStoreToBWDSAdapter",["BWDSUtil","bw/storage/BWDSError","bw/logging"],function(e,t,r){"use strict";var n=r.createLogger("AsyncKeyStoreToBWDSAdapter"),o=function(r){function o(t,r){i.queue.executeSequential(function(n){try{t(n)}catch(t){console.error("AsyncBWDS: Uncaught error: "+t),e.handleException(t,r,n)}})}var i={};return i.async=r,i.queue=e.newCallbackQueue(),i.readNoSync=function(e,t,r){n.debug("readNoSync "+e),i.async.getItemsAsync([e],function(r){if(r.hasOwnProperty(e)){var n=JSON.parse(r[e].attribs);n.removed===!1?t(r[e].value,i.fileStat(e,n)):t(null,i.fileStat(e,n))}else t(null,null)},function(e){r(e)})},i.read=function(r,n){o(function(o){i.readNoSync(r,function(r,i){null==r?e.callSafe(n,e.error(t.BWDS_ERROR_UNKNOWN,"AsyncBWDS Error: no such file"),null,i):e.callSafe(n,null,r,i),o()},function(t){e.handleException(t,n,o)})},n)},i.writeNoSync=function(t,r,o,a){n.debug("writeNoSync "+t+" "+r);var s=null==r?0:r.length;i.async.getItemsAsync([t],function(n){var c,u=e.getDateTime();n.hasOwnProperty(t)?(c=JSON.parse(n[t].attribs),c.updated_at=u,c.filesize=s,c.isdir=null==r,c.removed=!1,c.version=c.version+1,c.offline=!1):c={created_at:u,updated_at:u,filesize:s,isdir:null==r,removed:!1,version:1,backup_version:0,backup_date:null,offline:!1},i.async.setItemsAsync([{key:t,value:null==r?"":r,attribs:JSON.stringify(c)}],function(e){if(""==t)return void o(i.fileStat(t,c));var r=t.lastIndexOf("/"),n="";r!=-1&&(n=t.substring(0,r)),i.writeNoSync(n,null,o,a)},function(e){a(e)})},function(e){a(e)})},i.write=function(t,r,n){o(function(o){i.writeNoSync(t,null==r?"":r,function(t){e.callSafe(n,null,t),o()},function(t){e.handleException(t,n,o)})},n)},i.removeFiles=function(t,r,o){if(0==t.length)void 0!=r&&r();else{var a=t.shift(),s=a.attribs,c=e.getDateTime();s.removed=!0,s.offline=!1,s.updated_at=c,i.async.setItemsAsync([{key:a.name,value:"",attribs:JSON.stringify(s)}],function(){i.removeFiles(t,function(){r(s)},o)},function(){n.error("removeFiles, could not write new file attribs to clear, removing including attribs"),i.async.removeItemsAsync([a.name],function(){i.removeFiles(t,function(){r(s)},o)},o)})}},i.removeRecurse=function(e,t,r){if(0==e.length)void 0!=t&&t();else{var n=e.shift();i.async.getDirAttribs(n,function(n){var o=[];for(var a in n){var s=JSON.parse(n[a]);s.removed===!1&&(s.isdir===!0&&e.push(a),o.push({name:a,attribs:s}))}i.removeFiles(o,function(){i.removeRecurse(e,t,r)},r)},r)}},i.removeNoSync=function(r,o,a){n.debug("removeNoSync "+r),""==r?i.removeRecurse([r],o,a):i.async.getItemsAsync([r],function(n){if(n.hasOwnProperty(r)){var s=JSON.parse(n[r].attribs);s.removed===!1?s.isdir?i.removeFiles([{name:r,attribs:s}],function(){i.removeRecurse([r],o,a)},function(t){e.handleException(t,a)}):i.removeFiles([{name:r,attribs:s}],function(e){o(i.fileStat(r,e))},function(t){e.handleException(t,a)}):a(e.error(t.BWDS_ERROR_UNKNOWN,"AsyncBWDS Error: no such file"))}else a(e.error(t.BWDS_ERROR_UNKNOWN,"AsyncBWDS Error: no such file"))},function(t){e.handleException(t,a)})},i.remove=function(t,r){o(function(n){i.removeNoSync(t,function(){e.callSafe(r,null),n()},function(t){e.handleException(t,r,n)})},r)},i.dirNoSync=function(t,r,o){n.debug("dirNoSync "+t),i.async.getDirAttribs(t,function(n){var o=[];for(var i in n){var a=JSON.parse(n[i]);a.removed===!1&&""!=i&&o.push(e.trimLeadingSlash(i.substr(t.length)))}r(o.length>0?o:null)},function(e){o(e)})},i.dir=function(r,n){o(function(o){i.dirNoSync(r,function(i){null!==i?e.callSafe(n,null,i):""===r?e.callSafe(n,null,[]):e.callSafe(n,e.error(t.BWDS_ERROR_UNKNOWN,"AsyncBWDS Error: no such file")),o()},function(t){e.handleException(t,n,o)})},n)},i.fileStat=function(e,t){var r={name:e,size:t.filesize,created:t.created_at,modified:t.updated_at,isdir:t.isdir,removed:t.removed,version:t.version,backup_version:t.backup_version,backup_date:t.hasOwnProperty("backup_date")?t.backup_date:null,offline:!!t.hasOwnProperty("offline")&&t.offline};return r},i.dirStat=function(e,t,r,o){n.debug("dirNoSync "+e),i.async.getDirAttribs(e,function(e){var n=[];for(var o in e)""!==o&&n.push(i.fileStat(o,JSON.parse(e[o])));r(t,n)},function(e){o(e)})},i.statNoSync=function(e,t,r){n.debug("statNoSync "+e),i.async.getItemsAsync([e],function(n){if(n.hasOwnProperty(e)){var o=JSON.parse(n[e].attribs),a=i.fileStat(e,o);o.isdir?i.dirStat(e,a,t,r):t(a)}else t(null)},function(e){r(e)})},i.stat=function(r,n){o(function(o){i.statNoSync(r,function(r,i){null!==r?"undefined"==typeof i?e.callSafe(n,null,r):e.callSafe(n,null,r,i):e.callSafe(n,e.error(t.BWDS_ERROR_UNKNOWN,"AsyncBWDS Error: no such file")),o()},function(t){e.handleException(t,n,o)})},n)},i.setStatNoSync=function(r,o,a,s){n.debug("setStatNoSync "+r),i.async.getItemsAsync([r],function(n){if(!n.hasOwnProperty(r))return void s(e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"));var c=JSON.parse(n[r].attribs);for(var u in o)if("backup_date"==u)c.backup_date=o.backup_date;else{if("backup_version"!=u)return void s(e.error(t.BWDS_ERROR_WRONG_ATTRIB,"KeyStoreBWDS Error: Can't set attribute "+u));c.backup_version=o.backup_version}i.async.setItemsAsync([{key:r,value:n[r].value,attribs:JSON.stringify(c)}],function(e){a(i.fileStat(r,c))},function(e){s(e)})},function(e){s(e)})},i.setStat=function(t,r,n){o(function(o){i.setStatNoSync(t,r,function(t){e.callSafe(n,null,t),o()},function(t){e.handleException(t,n,o)})},n)},i.executeSync=function(e,t){i.queue.executeSequential(e,t)},i.clearAll=function(t){n.debug("clearAll"),i.async.clearAllAsync(function(){n.debug("AsyncBWDS.clearAll OK callback"),e.callSafe(t)},function(r){e.handleException(r,t)})},i};return o}),bwdefine("bw/storage/SyncKeyStoreToBWDSAdapter",["BWDSUtil","bw/storage/BWDSError","bw/logging"],function(e,t,r){"use strict";function n(t,r){try{t()}catch(t){o.error("Uncaught error: "+t),e.handleException(t,r)}}var o=r.createLogger("SyncKeyStoreToBWDSAdapter"),i=function(r){function i(r,n,o){return a.keystore.setItem(r,n)!==!1||(e.callSafe(o,e.error(t.BWDS_ERROR_FULL,"KeyStoreBWDS error: storage full"),null),!1)}var a={};return a.keystore=r,a.write=function(t,r,s){n(function(){o.debug("write "+t);var n,c,u=r.length,l=t.lastIndexOf(".");if(l==-1?(n=t,c=""):(n=t.substr(0,l),c=t.substr(l+1)),i(n,r,s)){if(""==n)return void e.callSafe(s,null,null);var f=n.lastIndexOf("/"),d="",S="";f!=-1&&(d=n.substring(0,f)),S=n.substring(f);var v,b=a.keystore.getItem(d),g=e.getDateTime();null===b?(v={},v[S]={type:c,created_at:g,updated_at:g,filesize:u,removed:!1,version:1,backup_version:0,backup_date:null,offline:!1}):(v=JSON.parse(b),v[S]?(v[S].type=c,v[S].updated_at=g,v[S].filesize=u,v[S].version=v[S].hasOwnProperty("version")?v[S].version+1:2,v[S].removed=!1,v[S].offline=!1):v[S]={type:c,created_at:g,updated_at:g,filesize:u,removed:!1,version:1,backup_version:0,backup_date:null,offline:!1});var m=a.fileStat(d,S,v[S]);a.write(d+".dir",JSON.stringify(v),function(t){e.callSafe(s,t,m)})}},s)},a.read=function(r,i){n(function(){o.debug("read "+r);var n,s,c=r.lastIndexOf(".");c==-1?(n=r,s=""):(n=r.substr(0,c),s=r.substr(c+1));var u=n.lastIndexOf("/"),l="",f="";u!=-1&&(l=n.substring(0,u)),f=n.substring(u);var d=a.keystore.getItem(l);if(null===d)return void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"),null,null);var S=JSON.parse(d);if(!S[f])return void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"BWKDLocal Error: unknown file"),null,null);if(s&&S[f].type!=s)return void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"),null,null);if(S[f].removed!==!0){var v=a.keystore.getItem(n);return void e.callSafe(i,null,v,a.fileStat(l,f,S[f]))}e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"BWKDLocal Error: removed file"),null,a.fileStat(l,f,S[f]))},i)},a.clearDir=function(e){var t=a.keystore.getItem(e);if(null!=t){var r=JSON.parse(t);for(var n in r){var i=r[n];"dir"==i.type&&""!=n&&a.clearDir(e+n),o.debug("Clearing: "+e+n),a.keystore.removeItem(e+n)}a.keystore.removeItem(e)}},a.clear=function(t,r){n(function(){if(o.debug("clear "+t),t)throw Error("clear(): Unexpected parameter");a.clearDir(""),e.callSafe(r,null)},r)},a.removeDir=function(t,r){o.debug("removeDir("+t+")");var n=a.keystore.getItem(t);if(null!=n){var s=JSON.parse(n),c=e.getDateTime();for(var u in s){var l=s[u];l.removed===!1&&("dir"===l.type?""!==u&&a.removeDir(t+u,r):(o.debug("Clearing: "+t+u),a.keystore.removeItem(t+u)),s[u].version=s[u].hasOwnProperty("version")?s[u].version+1:2,s[u].removed=!0,s[u].updated_at=c)}if(!i(t,JSON.stringify(s),r))return}},a.remove=function(r,i){n(function(){if(o.debug("remove "+r),""==r||null==r||void 0==r)return a.removeDir("",i),void e.callSafe(i,null);var n,s,c=r.lastIndexOf(".");c==-1?(n=r,s=""):(n=r.substr(0,c),s=r.substr(c+1));var u=n.lastIndexOf("/"),l="",f="";u!=-1&&(l=n.substring(0,u)),f=n.substring(u);var d=a.keystore.getItem(l);if(null===d)return void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"));var S=JSON.parse(d);if(S[f]){"dir"==S[f].type?a.removeDir(r,i):a.keystore.removeItem(n),S[f].removed=!0,S[f].version=S[f].hasOwnProperty("version")?S[f].version+1:2;var v=e.getDateTime();S[f].updated_at=v;var b=a.fileStat(l,f,S[f]);return void a.write(l+".dir",JSON.stringify(S),function(t){e.callSafe(i,t,b)})}return o.error("unknown file"),void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"))},i)},a.dir=function(r,i){n(function(){o.debug("dir "+r);var n,s;if(""!=r){var c=r.lastIndexOf("/"),u="",l="";if(c!=-1&&(u=r.substring(0,c)),l=r.substring(c),n=a.keystore.getItem(u),null===n)return void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown directory"));if(s=JSON.parse(n),s.hasOwnProperty(l)===!1||"dir"!==s[l].type)return void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown directory"))}n=a.keystore.getItem(r),s=JSON.parse(n);var f=[];for(var d in s)s[d].removed!==!0&&f.push(e.trimLeadingSlash(d)+("dir"==s[d].type?"":"."+s[d].type));e.callSafe(i,null,f)},i)},a.fileStat=function(e,t,r){var n={name:e+t+("dir"==r.type?"":"."+r.type),size:r.hasOwnProperty("filesize")?r.filesize:null==a.keystore.getItem(e+t)?0:a.keystore.getItem(e+t).length,created:r.created_at,modified:r.updated_at,isdir:"dir"==r.type,removed:r.hasOwnProperty("removed")&&r.removed===!0,version:r.version,backup_version:r.backup_version,backup_date:r.hasOwnProperty("backup_date")?r.backup_date:null,offline:!!r.hasOwnProperty("offline")&&r.offline};return n},a.dirStat=function(t,r,n){var o=a.keystore.getItem(t),i=JSON.parse(o),s=[];for(var c in i)s.push(a.fileStat(t,c,i[c]));e.callSafe(r,null,n,s)},a.stat=function(r,i){n(function(){if(o.debug("stat "+r),""==r)return void a.dirStat(r,i,{isdir:!0,name:""});var n,s,c=r.lastIndexOf(".");c==-1?(n=r,s=""):(n=r.substr(0,c),s=r.substr(c+1));var u=n.lastIndexOf("/"),l="",f="";u!=-1&&(l=n.substring(0,u)),f=n.substring(u);var d=a.keystore.getItem(l);if(null===d||""===d)return void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"));var S=JSON.parse(d);return S[f]?"dir"==S[f].type?void a.dirStat(r,i,a.fileStat(l,f,S[f])):void e.callSafe(i,null,a.fileStat(l,f,S[f])):void e.callSafe(i,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"))},i)},a.setStat=function(r,s,c){n(function(){if(o.debug("stat "+r),""==r)return void e.callSafe(c,e.error(t.BWDS_ERROR_WRONG_ATTRIB,"KeyStoreBWDS Error: Can't set attributes for directory"));var n,u,l=r.lastIndexOf(".");l==-1?(n=r,u=""):(n=r.substr(0,l),u=r.substr(l+1));var f=n.lastIndexOf("/"),d="",S="";f!=-1&&(d=n.substring(0,f)),S=n.substring(f);var v=a.keystore.getItem(d);if(null===v)return void e.callSafe(c,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"));var b=JSON.parse(v);if(b[S]){if("dir"==b[S].type)return void e.callSafe(c,e.error(t.BWDS_ERROR_WRONG_ATTRIB,"KeyStoreBWDS Error: Can't set attributes for directory"));for(var g in s)if("backup_date"==g)b[S].backup_date=s.backup_date;else{if("backup_version"!=g)return void e.callSafe(c,e.error(t.BWDS_ERROR_WRONG_ATTRIB,"KeyStoreBWDS Error: Can't set attribute "+g));b[S].backup_version=s.backup_version}if(!i(d,JSON.stringify(b),c))return;return void e.callSafe(c,null,a.fileStat(d,S,b[S]))}e.callSafe(c,e.error(t.BWDS_ERROR_UNKNOWN,"KeyStoreBWDS Error: unknown file"))},c)},a.executeSync=function(e,t){e(function(){})},a.clearAll=function(e){n(function(){a.clear("",e)},e)},a};return i}),bwdefine("BWDS",["bw/platform","BWKSLocal","bw/storage/WebSQLAsyncKeyStore","bw/storage/NativeSQLAsyncKeyStore","bw/storage/ProxiedAsyncKeyStore","bw/storage/BWDSError","bw/storage/AsyncKeyStoreToBWDSAdapter","bw/storage/SyncKeyStoreToBWDSAdapter"],function(e,t,r,n,o,i,a,s){var c,u=new s(t),l=new r,f=new a(l),d=new n,S=new a(d),v=e.getPlatform();return window.location.search.substring(1).indexOf("bwds-proxy")!==-1?(c=new a(new o("_storage")),console.log("BWDS: Proxy")):"ibw-platform-ipad-bookwidgets"===v?(c=S,window.BWKSNativeSQL=d,console.log("BWDS: Native")):"ibw-platform-ipad-ibooks"===v||"ibw-platform-osx-chrome"===v||"ibw-platform-osx-preview"===v||"ibw-platform-win32-preview"===v||"ibw-platform-win32-chrome"===v||"ibw-platform-chromebook-chrome"===v||"ibw-platform-android-chrome"===v?(console.log("BWDS: WebSQL"),c=f):(c=u,console.log("BWDS: Local")),c.test={BWKSWebSQL:l,BWDSLocal:u,BWDSWebSQL:f},c}),bwdefine("BWIS",["BWDSUtil","bw/storage/BWDSError","jquery"],function(e,t,r){return{uploadImage:function(n,o){r.ajax({url:"http://api.ibook-widgets.com/api/v1/image/upload",type:"POST",data:{content:n},success:function(e){var t=e;console.log("Image stored to BookWidgets: "+t),o(null,t)},error:function(r,n,i){o(e.error(t.BWDS_ERROR_INTERNAL,n))}})}}});